# Get Product Libraries by project Ids

Returns all libraries that are included in a given projects

Endpoint: POST /api/v2.0/products/{productToken}/libraries/byProjects
Version: 2.0
Security: bearer-key

## Query parameters:

  - `pageSize` (string)

  - `page` (string)

  - `search` (any)
    Filter your search to return items whose property has a specific value.
Use the syntax: property:operation:value where a colon (:) separates between property, operation and value.
+ Property: the name of the property of the item
+ Operation:
    + equals - true if the value is identical to this value.
    + in - true if the value is identical to one of the items in this comma-separated list. E.g. in:value1,value2,value3
    + like - true if the property's value is contained within this value
    + regex - true if this regular expression resolves as true.
        The regex is not case sensitive, and special characters must be escaped with a backslash.
        Special characters include space, double quote ("), '', '#', '%', '{', '}', vertical bar ('|'), backslash, '^'.
        To pass an escaped character in a URL in Postman, encode it first.
        E.g. to return all items whose value begins with a or A, use regex:^a
+ Value: the value of the property.

To combine multiple filters, separate each filter with a semicolon with no space. E.g.  property1:operation1:value1;property2:operation2:value2

This endpoint supports filtering on the following properties and its supported operators:
+ description:[like | equals | regex]:value
+ directDependency:[like | equals | regex]:value
+ hasNotice:[like | equals | regex]:value
+ license:[like | equals | regex | in]:value
+ locations:[like | equals | regex]:value
+ name:[like | equals | regex]:value
+ numberOfLicenses:[equals | gt]:value
+ projectName:[like | equals | regex]:value
+ type:[like | in | equals | regex]:value

  - `sort` (any)
    Sort search results alphabetically on an item's property by entering sort= followed by the property name.
E.g. enter sort=email to sort alphabetically by their email addresses from a-z ascending.To sort in descending order (z-a), add a minus sign ('-'). E.g. sort=-email.

You can sort by the following properties:
+ description
+ directDependency
+ hasNotice
+ license
+ locations
+ name
+ numberOfLicenses
+ projectName
+ type

  - `optionalColumns` (string)
    Used to add location information about the library
    Enum: "locations"

  - `includeNotices` (boolean)

  - `extraInformation` (boolean)

## Path parameters:

  - `productToken` (string, required)
    product UUID (by running Entities - Organization > Get Organization Products) or Product Token (from the Mend SCA App: Integrate tab > Product Token).

## Request fields (application/json):

  - `projectIdentifiers` (array, required)
    Example: ["123e4567-e89b-12d3-a456-426655440000"]

## Response 200 fields (application/json):

  - `supportToken` (string)
    Example: "1171c60d"

  - `retVal` (array)

  - `retVal.uuid` (string)
    Example: "123e4567-e89b-12d3-a456-426655440000"

  - `retVal.name` (string)
    Example: "dbus-1.10.24-13.el7_6.x86_64.rpm"

  - `retVal.artifactId` (string)
    Example: "kind-of-6.0.2.tgz"

  - `retVal.groupId` (string)
    Example: "kind-of"

  - `retVal.version` (string)

  - `retVal.architecture` (string)

  - `retVal.languageVersion` (string)

  - `retVal.classifier` (string)

  - `retVal.extension` (string)

  - `retVal.sha1` (string)
    Example: "01146b36a6218e64e58f3a8d66de5d7fc6f6d051"

  - `retVal.description` (string)
    Example: "Get the native type of a value."

  - `retVal.type` (string)
    Example: "javascript/Node.js"

  - `retVal.libraryType` (string)

  - `retVal.directDependency` (boolean)

  - `retVal.purl` (string)
    Example: "pkg:maven/commons-beanutils/commons-beanutils@1.8.0?type=jar"

  - `retVal.extraInfo` (object)

  - `retVal.extraInformation` (object)

  - `retVal.extraInformation.distributionUrl` (string)

  - `retVal.extraInformation.downloadUrl` (string)

  - `retVal.extraInformation.releaseDate` (string)

  - `retVal.extraInformation.packageManagerRepository` (string)

  - `retVal.extraInformation.homePage` (string)

  - `retVal.extraInformation.repositoryUrl` (string)

  - `retVal.extraInformation.author` (string)

  - `retVal.licenses` (array)

  - `retVal.licenses.uuid` (string)
    Example: "123e4567-e89b-12d3-a456-426655440000"

  - `retVal.licenses.name` (string)
    Example: "MIT"

  - `retVal.licenses.assignedByUser` (boolean)

  - `retVal.licenses.licenseReferences` (array)

  - `retVal.licenses.licenseReferences.uuid` (string)
    Example: "123e4567-e89b-12d3-a456-426655440000"

  - `retVal.licenses.licenseReferences.type` (string)
    Example: "ARTIFACT_DESCRIPTOR"

  - `retVal.licenses.licenseReferences.liabilityReference` (string)
    Example: "https://repo.maven.apache.org/maven2/org/jruby/ext/posix/jna-posix/1.0.3/jna-posix-1.0.3.pom"

  - `retVal.licenses.licenseReferences.assignedBy` (object)

  - `retVal.licenses.licenseReferences.assignedBy.uuid` (string, required)
    Example: "123e4567-e89b-12d3-a456-426655440000"

  - `retVal.licenses.licenseReferences.assignedBy.name` (string)
    Example: "Jon Smith"

  - `retVal.licenses.licenseReferences.assignedBy.email` (string)
    Example: "jon.smith@mail.com"

  - `retVal.licenses.licenseReferences.assignedBy.userType` (string)
    Enum: "REGULAR", "SERVICE", "SCAN_SUMMARY_RECEIVER"

  - `retVal.licenses.licenseReferences.assignedBy.accountStatus` (string)
    Enum: "ACTIVE", "INACTIVE", "LOCKOUT"

  - `retVal.licenses.licenseReferences.textUrl` (string)

  - `retVal.licenses.licenseReferences.customDisclaimer` (string)

  - `retVal.licenses.licenseReferences.information` (string)
    Example: "distribution=repo&remoteUrl=https://repo.maven.apache.org/maven2/org/jruby/ext/posix/jna-posix/1.0.3/jna-posix-1.0.3.pom"

  - `retVal.copyrightReferences` (array)

  - `retVal.copyrightReferences.type` (string)
    Enum: "TEXT_IN_FILE", "ARTIFACT_DESCRIPTOR", "PROJECT_HOMEPAGE", "USER", "UNSPECIFIED"

  - `retVal.copyrightReferences.copyright` (string, required)
    Example: "Copyright 2021 x greater by the end of"

  - `retVal.copyrightReferences.customDisclaimer` (string)

  - `retVal.copyrightReferences.createdAt` (string)

  - `retVal.copyrightReferences.textUrl` (string)

  - `retVal.copyrightReferences.startYear` (string)
    Example: "2021"

  - `retVal.copyrightReferences.endYear` (string)
    Example: "2022"

  - `retVal.copyrightReferences.author` (string)
    Example: "x greater by the end of"

  - `retVal.copyrightReferences.referenceInfo` (string)
    Example: "x greater by the end of"

  - `retVal.securityRisks` (array)

  - `retVal.securityRisks.sourceUrl` (string)

  - `retVal.securityRisks.riskFactor` (string)
    Enum: "NO_FINDINGS", "UNCONFIRMED_UNSAFE", "CONFIRMED_UNSAFE", "KNOWN_FALSE_POSITIVE"

  - `retVal.noticeReference` (object)

  - `retVal.noticeReference.text` (string, required)
    Example: "Developed internally"

  - `retVal.noticeReference.reference` (string)
    Example: "https://github.com/..."

  - `retVal.proprietaryInfo` (object)

  - `retVal.proprietaryInfo.ruleDescription` (string)

  - `retVal.proprietaryInfo.rulePattern` (string)

  - `retVal.proprietaryInfo.comment` (string)

  - `retVal.proprietaryInfo.userInfo` (object)

  - `retVal.proprietaryInfo.userInfo.uuid` (string, required)
    Example: "123e4567-e89b-12d3-a456-426655440000"

  - `retVal.proprietaryInfo.userInfo.name` (string)
    Example: "Jon Smith"

  - `retVal.proprietaryInfo.userInfo.email` (string)
    Example: "jon.smith@mail.com"

  - `retVal.proprietaryInfo.userInfo.userType` (string)
    Enum: "REGULAR", "SERVICE", "SCAN_SUMMARY_RECEIVER"

  - `retVal.proprietaryInfo.userInfo.accountStatus` (string)
    Enum: "ACTIVE", "INACTIVE", "LOCKOUT"

  - `retVal.proprietaryInfo.proprietaryMarkType` (string)
    Enum: "BY_RULE", "BY_USER"

  - `retVal.locations` (array)

  - `retVal.locations.localPath` (string)
    Example: "C:\\\\Users\\\\user\\\\.m2\\\\repository\\\\commons-io-1.4.jar"

  - `retVal.locations.dependencyFile` (string)
    Example: "C:\\\\GitHubRepos\\\\Pipline\\\\EUA\\\\plugins-automation\\\\fsa\\\\tests\\\\EUA\\\\Java\\\\bigProjectsMaven\\\\WST_417\\\\Data\\\\ksa\\\\ksa-web-core\\\\pom.xml"

  - `retVal.attributionReportSettings` (object)

  - `retVal.attributionReportSettings.excluded` (boolean)

  - `retVal.dependencyType` (string)

  - `retVal.violations` (integer)
    Example: 22

  - `retVal.workflowUuids` (array)
    Example: 2

  - `retVal.violatingFindings` (integer)
    Example: 2

  - `retVal.trackedIssue` (object)

  - `retVal.trackedIssue.uuid` (string)

  - `retVal.trackedIssue.issueId` (string)

  - `retVal.trackedIssue.origin` (string)

  - `retVal.trackedIssue.issueKey` (string)

  - `retVal.trackedIssue.account` (object)

  - `retVal.trackedIssue.account.uuid` (string)

  - `retVal.trackedIssue.account.name` (string)

  - `retVal.trackedIssue.domain` (object)

  - `retVal.trackedIssue.domain.uuid` (string)

  - `retVal.trackedIssue.domain.name` (string)

  - `retVal.trackedIssue.application` (object)

  - `retVal.trackedIssue.application.uuid` (string)

  - `retVal.trackedIssue.application.name` (string)

  - `retVal.trackedIssue.project` (object)

  - `retVal.trackedIssue.project.uuid` (string)

  - `retVal.trackedIssue.project.name` (string)

  - `retVal.trackedIssue.status` (string)
    Enum: "PENDING", "IN_PROGRESS", "SUCCESS", "FAILED", "DELETED"

  - `retVal.trackedIssue.issueStatus` (string)

  - `retVal.trackedIssue.failureReason` (string)

  - `retVal.trackedIssue.errorMessage` (string)

  - `retVal.trackedIssue.publicLink` (string)

  - `retVal.trackedIssue.creationDate` (string)

  - `retVal.trackedIssue.updatedAt` (string)

  - `retVal.trackedIssue.createdBy` (object)

  - `retVal.trackedIssue.createdBy.uuid` (string)

  - `retVal.trackedIssue.createdBy.name` (string)

  - `retVal.trackedIssue.ticketType` (string)
    Enum: "SECURITY", "LEGAL"

  - `retVal.project` (object)

  - `retVal.project.uuid` (string)
    Example: "123e4567-e89b-12d3-a456-426655440000"

  - `retVal.project.name` (string)
    Example: "My Project"

  - `retVal.project.path` (string)
    Example: "My Product"

  - `retVal.project.productName` (string)
    Example: "My Product"

  - `retVal.project.productUuid` (string)
    Example: "123e4567-e89b-12d3-a456-426655440000"

## Response 400 fields (*/*):

  - `supportToken` (string)
    Example: "1171c60d"

## Response 403 fields (*/*):

  - `supportToken` (string)
    Example: "1171c60d"


